﻿using System.Security.Cryptography;
using System.Text;

namespace FwsPoly.SDK.Crypts
{
    internal class WATCrypt
    {
        byte[] skey = new byte[8];

        public WATCrypt(string strKey)
        {
            skey = Encoding.ASCII.GetBytes(strKey);
        }

        public string Encrypt(string p_data)
        {
            if (skey.Length != 8)
            {
                throw new Exception("Invalid key. Key length must be 8 byte.");
            }

            DESCryptoServiceProvider dESCryptoServiceProvider = new DESCryptoServiceProvider();
            dESCryptoServiceProvider.Key = skey;
            dESCryptoServiceProvider.IV = skey;
            MemoryStream memoryStream = new MemoryStream();
            CryptoStream cryptoStream = new CryptoStream(memoryStream, dESCryptoServiceProvider.CreateEncryptor(), CryptoStreamMode.Write);
            byte[] bytes = Encoding.UTF8.GetBytes(p_data.ToCharArray());
            cryptoStream.Write(bytes, 0, bytes.Length);
            cryptoStream.FlushFinalBlock();
            return Convert.ToBase64String(memoryStream.ToArray());
        }

        public string Decrypt(string p_data)
        {
            DESCryptoServiceProvider dESCryptoServiceProvider = new DESCryptoServiceProvider();
            dESCryptoServiceProvider.Key = skey;
            dESCryptoServiceProvider.IV = skey;
            MemoryStream memoryStream = new MemoryStream();
            CryptoStream cryptoStream = new CryptoStream(memoryStream, dESCryptoServiceProvider.CreateDecryptor(), CryptoStreamMode.Write);
            byte[] array = Convert.FromBase64String(p_data);
            cryptoStream.Write(array, 0, array.Length);
            cryptoStream.FlushFinalBlock();
            return Encoding.UTF8.GetString(memoryStream.GetBuffer()).Trim(new char[1]);
        }
    }
}
